"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getTmpFile = void 0;

var _os = require("os");

var _utils = require("@fesjs/utils");

var _index = require("./index");

function getModels(files, absSrcPath) {
  const sortedModels = (0, _index.genModels)(files, absSrcPath);
  return sortedModels.map(ele => `'${ele.namespace.replace(/'/g, "\\'")}': ${ele.importName}`).join(', ');
}

function getExtraModels(models = [], absSrcPath) {
  const extraModels = (0, _index.genExtraModels)(models, absSrcPath);
  return extraModels.map(ele => `'${ele.namespace}': ${ele.exportName || ele.importName}`).join(', ');
}

function getExtraImports(models = [], absSrcPath) {
  const extraModels = (0, _index.genExtraModels)(models, absSrcPath);
  return extraModels.map(ele => {
    if (ele.exportName) {
      return `import { ${ele.exportName} } from '${(0, _utils.winPath)(ele.importPath.replace(/'/g, "\\'"))}';`;
    }

    return `import ${ele.importName} from '${(0, _utils.winPath)(ele.importPath.replace(/'/g, "\\'"))}';`;
  }).join(_os.EOL);
}

const getTmpFile = (files, extra = [], absSrcPath) => {
  const userImports = (0, _index.genImports)(files);
  const userModels = getModels(files, absSrcPath);
  const extraImports = getExtraImports(extra, absSrcPath);
  const extraModels = getExtraModels(extra, absSrcPath);
  return {
    userImports,
    userModels,
    extraImports,
    extraModels
  };
};

exports.getTmpFile = getTmpFile;